defmodule RefInspector.Plug.Mixfile do
  use Mix.Project

  @url_github "https://github.com/elixir-inspector/ref_inspector_plug"

  def project do
    [
      app: :ref_inspector_plug,
      name: "RefInspector Plug",
      version: "0.1.0",
      elixir: "~> 1.5",
      aliases: aliases(),
      deps: deps(),
      description: "RefInspector Plug",
      docs: docs(),
      elixirc_paths: elixirc_paths(Mix.env()),
      package: package(),
      preferred_cli_env: [
        coveralls: :test,
        "coveralls.detail": :test,
        "coveralls.travis": :test
      ],
      test_coverage: [tool: ExCoveralls]
    ]
  end

  defp aliases do
    [
      test: [
        "ref_inspector.download --force",
        "test"
      ]
    ]
  end

  defp deps do
    [
      {:credo, "~> 1.0", only: :dev, runtime: false},
      {:dialyxir, "~> 1.0.0-rc", only: :dev, runtime: false},
      {:ex_doc, ">= 0.0.0", only: :dev},
      {:excoveralls, "~> 0.10", only: :test},
      {:plug, "~> 1.0"},
      {:ref_inspector, "~> 1.0"}
    ]
  end

  defp docs do
    [
      main: "RefInspector.Plug",
      source_ref: "v0.1.0",
      source_url: @url_github
    ]
  end

  defp elixirc_paths(:test), do: ["lib", "test/helpers"]
  defp elixirc_paths(_), do: ["lib"]

  defp package do
    %{
      files: ["CHANGELOG.md", "LICENSE", "mix.exs", "README.md", "lib"],
      licenses: ["Apache 2.0"],
      links: %{"GitHub" => @url_github},
      maintainers: ["Marc Neudert"]
    }
  end
end
